/* cl -MT testwait.c */

#include <windows.h>

#include <stdio.h>

HANDLE hEvent1;
HANDLE hEvent2;
HANDLE hEvent3;

HANDLE hEvents[3];

DWORD WINAPI ThreadProc(void *lpParameter)
{
  DWORD Returned;

  printf("Thread Started %08X\n",(DWORD)lpParameter);

  while(1)
  {
    Returned = WaitForMultipleObjects(3, hEvents, FALSE, INFINITE);

    if (Returned == WAIT_OBJECT_0 + 0)
    {
      puts("Event 1");
      ResetEvent(hEvent1);
    }
    else if (Returned == WAIT_OBJECT_0 + 1)
    {
      puts("Event 2");
      ResetEvent(hEvent2);
    }
    if (Returned == WAIT_OBJECT_0 + 2)
    {
      puts("Event 3");
      ResetEvent(hEvent3);
    }
  }

  return(1234);
}

int main(int argc, char **argv)
{
  hEvents[0] = hEvent1 = CreateEvent(0, TRUE, FALSE, NULL);

  hEvents[1] = hEvent2 = CreateEvent(0, TRUE, FALSE, NULL);

  hEvents[2] = hEvent3 = CreateEvent(0, TRUE, FALSE, NULL);

  CreateThread(NULL, 0 , ThreadProc, hEvent1, 0, NULL);

  CreateThread(NULL, 0 , ThreadProc, hEvent2, 0, NULL);

  CreateThread(NULL, 0 , ThreadProc, hEvent3, 0, NULL);

  printf("Press 1,2,3 or Q to quit\n");

  while(1)
  {
    int x;

    x = getch();

    printf("%c\n",x);

    if ((x == 'Q') || (x == 'q') || (x == 0x1B))
      break;

    if (x == '1')
      SetEvent(hEvent1);
    else if (x == '2')
      SetEvent(hEvent2);
    else if (x == '3')
      SetEvent(hEvent3);
  }

  CloseHandle(hEvent1);

  CloseHandle(hEvent2);

  CloseHandle(hEvent3);

  return(0);
}

